

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JPanel;

/**
 * Vlilehtien abstrakti ylluokka. Eri komponentteja sisltvt vlilehdet (tabs)
 * periytetn tst luokasta. Aliluokat antavat toteutuksen initialize -metodille
 * jossa sijoittelevat haluamansa Swing -komponentit paneeliin. Tm luokka antaa mys
 * perustoteutuksen ActionListener- tyyppiselle tapahtumienkuuntelijalle, jolloin
 * jokaisen aliluokan ei tarvitse erikseen toteuttaa omaa kuuntelijaa vaan ne voivat
 * kytt valmista ylluokan toteutusta.
 * 
 */
public abstract class ComponentTab extends JPanel implements ActionListener {

	protected SwingComponents parent;
	
	public ComponentTab(SwingComponents parent) {
		this.parent = parent;
		initialize();
	}

	/**
	 * Perustoteutus tapahtumakuuntelijalle.
	 * 
	 */
	public void actionPerformed(ActionEvent e) {
		parent.getJTextArea().append(e.getSource()+"\n");
		
	}

	/**
	 * Abstrakti metodi, jonka aliluokat toteuttavat.
	 * Tss metodissa toteutuksen antava luokka asettelee 
	 * komponentit paneeliin.
	 *
	 */
	protected abstract void initialize();
	
}
