

import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

/**
 * Dialogeja esittelev vlilehti. 
 * 
 * 
 *
 */
public class DialogTab extends ComponentTab {

	private JPanel dialogs;
	
	public DialogTab(SwingComponents parent) {
		super(parent);
	}
	
	@Override
	protected void initialize() {
		this.add(getDialogPanel());
	}

	private JPanel getDialogPanel() {
		if (dialogs == null) {
			dialogs = new JPanel();
			dialogs.setBorder(new TitledBorder("Dialogs"));
			
			JButton d1 = new JButton("Input dialog");
			d1.addActionListener(new ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String answer = JOptionPane.showInputDialog(parent, "Where are all the WMDs?");
					
					if (answer != null && !"".equals(answer)) {
						parent.getJTextArea().append("The answer is: "+answer+"\n");	
					}
					
				}
			});
		
			dialogs.add(d1);
			dialogs.add(Box.createRigidArea(new Dimension(0, 15)));
			
			JButton d2 = new JButton("Message dialog");
			d2.addActionListener(new ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					JOptionPane.showMessageDialog(parent, "Lesson #8: Be prepared to reexamine your reasoning");
				}
			});
			dialogs.add(d2);
			dialogs.add(Box.createRigidArea(new Dimension(0, 15)));		
			
			JButton d3 = new JButton("Warning dialog");
			d3.addActionListener(new ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					JOptionPane.showMessageDialog(parent, "The core is about to melt...", "Thought you might wanna know", JOptionPane.WARNING_MESSAGE);
				}
			});
			dialogs.add(d3);
			
			JButton d4 = new JButton("Confirmation dialog");
			d4.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int result = JOptionPane.showConfirmDialog(parent, "Are you really sure?");
					
					switch (result) {
						case JOptionPane.YES_NO_OPTION: {
							parent.getJTextArea().append("Well, good for you\n");
							break;
						}

						case JOptionPane.NO_OPTION: {
							parent.getJTextArea().append("Is that so?\n");
							break;
						}

						case JOptionPane.CANCEL_OPTION: {
							parent.getJTextArea().append("What part of the question you did not understand?\n");
							break;
						}

						
					}
					
				}
			});
			dialogs.add(d4);
			
		}
	
		return dialogs;
	}
	
}


