

import java.awt.BorderLayout;

import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.JTree;
import javax.swing.event.TableModelListener;
import javax.swing.event.TreeSelectionListener;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;
import javax.swing.tree.TreeSelectionModel;

/**
 * Taulukkoja ja puita esittelev vlilehti.
 * 
 *
 */
public class TableAndTreeTab extends ComponentTab {

	private JTree jTree;
	private JTable jTable;
	private JSplitPane jSplitPane;
		
	public TableAndTreeTab(SwingComponents parent) {
		super(parent);
	}
	
	@Override
	protected void initialize() {
		this.setLayout(new BorderLayout());
		this.add(getJSplitPane(), BorderLayout.CENTER);
	}

	private JSplitPane getJSplitPane() {
		if (jSplitPane == null) {
			jSplitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
			jSplitPane.setLeftComponent(new JScrollPane(getJTree()));
			jSplitPane.setRightComponent(new JScrollPane(getJTable()));
			jSplitPane.setDividerLocation(200);
		}
		
		return jSplitPane;
	}

	private JTable getJTable() {
		if (jTable == null) {			

			// sarakkeiden nimet sek dummy dataa taulukkoon
			final String[] colNames = {"Filename", "Respawn delay", "Respawn type"};
			final Object[][] data = {
						{"03_Talvisota_GuerillaWarfare.FDF_Rukajarvi_w.pbo", 15, "BIRD"},
						{"FDF-SP-ghosts_of_karelia.FDF_eastborder.pbo", 10, "INSTANT"},
						{"09_Talvisota_RedsnowHill.FDF_Rukajarvi_w.pbo", 5, "BASE"},
						{"Pyhjrven kyl.FDF_Rukajarvi_w.pbo", 0, "NONE"},
						{"Lumessakahlaajat osa1 MP.FDF_Rukajarvi_w.pbo", 3, "GROUP"}
					
			};
			
			jTable = new JTable(data, colNames);

			// asetetaan viimeiselle sarakkeelle combobox editori
			
			JComboBox comboBox = new JComboBox();
			comboBox.addItem("NONE");
			comboBox.addItem("BIRD");
			comboBox.addItem("INSTANT");
			comboBox.addItem("BASE");
			comboBox.addItem("GROUP");
			comboBox.addItem("SIDE");			
			
			TableColumn col = jTable.getColumnModel().getColumn(2);
			col.setCellEditor(new DefaultCellEditor(comboBox));
			
			jTable.getColumnModel().getColumn(0).setMinWidth(250);

			// listn taulukon datamalliin kuuntelija, joka havaitsee muutokset
			// taulukon arvoissa
			jTable.getModel().addTableModelListener(new TableModelListener() {
				public void tableChanged(javax.swing.event.TableModelEvent e) {
					int row = e.getFirstRow();
					int col = e.getColumn();
					TableModel model = (TableModel)e.getSource();
					String name = model.getColumnName(col);
					String value = model.getValueAt(row, col).toString();
					parent.getJTextArea().append("Table data on column "+name+" at row "+(row+1)+" was changed to: "+value+"\n");
				}
			});
			
		}
		return jTable;
	}

	private JTree getJTree() {
		if (jTree == null) {
			jTree = new JTree();
		
			// listn kuuntelija, joka kuuntelee puussa tapahtuvia valintoja ja tulostaa valitun polun
			jTree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
			jTree.addTreeSelectionListener(new TreeSelectionListener() {
				public void valueChanged(javax.swing.event.TreeSelectionEvent e) {
					parent.getJTextArea().append("Tree path was selected: "+e.getPath()+"\n");
				}
			});
		
		}
		return jTree;
	}	

	
	
}
