

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

/**
 * Swingin tekstikomponentteja esittelev vlilehti.
 *  
 * 
 *
 */
public class TextComponentTab extends ComponentTab {

	
	private JTextField jTextField;
	private JTextArea jTextArea;
	private JEditorPane jEditorPane;
	private JSplitPane jSplitPane;
	
	private JPanel inputPanel;
	
	public TextComponentTab(SwingComponents parent) {
		super(parent);
	}

	protected void initialize() {
		this.setLayout(new BorderLayout());
		
		this.add(getInputPanel(), BorderLayout.NORTH);
		this.add(getJSplitPane(), BorderLayout.CENTER);
	}	
	

	private JPanel getInputPanel() {
		if (inputPanel == null) {
		
			inputPanel = new JPanel();			
			inputPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
			inputPanel.setLayout(new BoxLayout(inputPanel, BoxLayout.X_AXIS));
			inputPanel.add(new JLabel("Message"));
			inputPanel.add(Box.createRigidArea(new Dimension(5, 0)));
			inputPanel.add(getJTextField());
			
		}
	
		return inputPanel;
	}
	
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();			
		
			jTextField.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					
					String text = jTextField.getText();
					getJTextArea().setText(text);
					getJEditorPane().setText("<h1>"+text+"</h1>");
				}
			});
		}
		
		return jTextField;
	}

	private JSplitPane getJSplitPane() {
		if (jSplitPane == null) {
			jSplitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
			jSplitPane.setLeftComponent(new JScrollPane(getJTextArea()));
			jSplitPane.setRightComponent(new JScrollPane(getJEditorPane()));
			jSplitPane.setDividerLocation(400);
		}
		
		return jSplitPane;
	}

	private JEditorPane getJEditorPane() {
		if (jEditorPane == null) {
			jEditorPane = new JEditorPane("text/html", "<h1>JEditorPane configured for HTML</h1><center><img src=\"http://www.kerrolisaa.com/kuvat/DNATG.gif\"></center>");			
			jEditorPane.setEditable(false);
		}
		
		return jEditorPane;
	}

	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextArea("PLAIN TEXT");			
		}
		
		return jTextArea;
	}

	
	
}
