

import java.awt.Dimension;

import javax.swing.Action;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

/**
 * Paneeli joka sislt sytekentn sek nappulan, jota painamalla 
 * haluttu RSS sivu ladataan.  
 * 
 *
 */
public class InputPanel extends JPanel {

	private JTextField jTextField;
	private JButton jButton;
	private Action openAction;
	
	public InputPanel(Action openAction) {
		super();
		this.openAction = openAction;
		
		this.setBorder(new EmptyBorder(5, 0, 10, 0));
		this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		this.add(new JLabel("RSS URL"));
		this.add(Box.createRigidArea(new Dimension(5, 0)));
		this.add(getJTextField());
		this.add(Box.createRigidArea(new Dimension(5, 0)));
		this.add(getJButton());
		
	}
	
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setAction(openAction);
			jTextField.setText("http://");
			jTextField.setCaretPosition(7);			
		}
		
		return jTextField;
	}
	
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton(openAction);
			jButton.setText("Open");
		}
	
		return jButton;
	}
	
	
	public String getInput() {
		return jTextField.getText();
	}

	
}
