

import java.awt.BorderLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.border.EmptyBorder;

/**
 * Tilapaneeli, jonka tehtvn on nytt kulloinkin tapahtuvan toiminnan tila.
 * Paneeli sislt tekstuaalisen viestin kynniss olevasta tilasta sek edistymispalkin.
 * Edistymispalkki ei mittaa tapahtuvan toiminnon todellista edistymist vaan sen
 * tarkoituksena on viestitt kyttjlle, ett yliptn jotain tapahtuu.
 * 
 *
 */
public class StatusPanel extends JPanel {

	private JLabel jLabel;
	private JProgressBar jProgressBar;
	
	
	public StatusPanel() {
		super();
		
		this.setLayout(new BorderLayout());
		this.setBorder(new EmptyBorder(5, 0, 0, 0));
		this.add(getJLabel(), BorderLayout.WEST);
		this.add(getJProgressBar(), BorderLayout.EAST);
	}


	private JLabel getJLabel() {
		if (jLabel == null) {
			jLabel = new JLabel("Ready");
		}
		return jLabel;
	}


	private JProgressBar getJProgressBar() {
		if (jProgressBar == null) {
			jProgressBar = new JProgressBar();
		}
		return jProgressBar;
	}

	public void setStatus(String message, boolean inProgress) {
		getJLabel().setText(message);
		getJProgressBar().setIndeterminate(inProgress);
	}
}
